#ifdef GL_ES
#define LOWP lowp
precision mediump float;
#else
#define LOWP
#endif

varying LOWP vec4 vColor;
varying vec2 vTexCoord;

//our texture samplers
uniform sampler2D u_texture; //diffuse map

void main() {
	vec4 DiffuseColor = texture2D(u_texture, vTexCoord);
	gl_FragColor = vColor * DiffuseColor;
	
   float perspective_far = 250.0;
   float fog_cord = (gl_FragCoord.z / gl_FragCoord.w) / perspective_far;
   float fog_density = 2.5;
   float fog = fog_cord * fog_density;
   vec4 frag_color = texture2D(u_texture, vTexCoord);
   vec4 fog_color = vec4(0.5,0.5,0.5,1.0);
   gl_FragColor = mix(fog_color, frag_color, clamp(1.0-fog, 0.0, 1.0));
}